; Try to figure out cache size.
; 2000-07-06 / lth

(require 'format)

(define (cache-sizes)
  (do ((vsize 2048 (* vsize 2)))        ; elements
      ((> vsize 2097152))
    (let ((v (make-vector vsize 0))
          (iter (/ 2097152 vsize)))
      (let ((t1 (memstats-elapsed-time (memstats))))
        (do ((i 0 (+ i 1)))
            ((= i iter))
          (do ((j 0 (+ j 1)))
              ((= j vsize))
            (vector-ref v j)))
        (let ((t (- (memstats-elapsed-time (memstats)) t1)))
          (format #t "~8@a KB: ~a ms~%" (/ (* vsize 4) 1024) t))))))

; Put codevector in nonmoveable memory to reduce noise from changing
; alignment of the inner loop.

(procedure-set! cache-sizes 0
                (let* ((code (procedure-ref cache-sizes 0))
                       (x (make-nonrelocatable-bytevector 
                           (bytevector-length code))))
                  (do ((i 0 (+ i 1)))
                      ((= i (bytevector-length code))
                       x)
                    (bytevector-set! x i (bytevector-ref code i)))))

; eof
