; Various data that do not vary with the collector type.
; 2000-08-31 / lth

; Canonical benchmark names, aka benchmark designators.
;   bm ::= (n name)

; This is defined to be sorted in the canonical presentation order!

(define benchmark-names
  '((5 earley:12)
    (1 gcbench:5)
    (1 gcold:25_0_1_0_200)
    (1 gcold:25_0_1_1000_200)
    (1 gcold:25_0_10_1000_200)
    (1 nboyer:3)
    (5 nboyer:3)
    (1 perm:200_8_10_1)
    (1 perm:25_8_10_8)
    (5 sboyer:4)
    (1 twobitlong)
    (1 twobitshort)
    (5 twobitshort)))

; In bytes of storage.

(define (canonical-allocation bm)       ; Allocation volume
  (let ((probe (assoc bm `(((1 gcbench:5)   . 1757.0)
                           ((1 gcold:25_0_1_0_200) . 347.0)
                           ((1 gcold:25_0_1_1000_200) . 402.0)
                           ((1 gcold:25_0_10_1000_200) . 264.0)
                           ((1 nboyer:3)    .   99.0)
                           ((1 perm:200_8_10_1) . 229.0)
                           ((1 perm:25_8_10_8) . 229.0)
                           ((1 twobitshort) .  119.5)
                           ((1 twobitlong)  .  665.0)
                           ((5 earley:12)   .  299.0)
                           ((5 nboyer:3)    .  497.0)
                           ((5 sboyer:4)    .  259.0)
                           ((5 twobitshort) .  575.5)))))
    (if probe
        (* 1024 1024 (cdr probe))
        (error "canonical-allocation: can't find " bm))))

; In bytes of storage.

(define (static-size bm)                ; Size of non-text static area
  (if (or (eq? (cadr bm) 'twobitshort)
          (eq? (cadr bm) 'twobitlong))
      (* 260000 4)                      ; approximate but close
      (* 119000 4)))                    ; ditto

; In bytes of storage.

(define (profiled-peak-usage bm)        ; From careful profiling

  ; Note, table contains values in words of storage; these are 
  ; scaled below.  (Historical accident because profiler reports
  ; storage in words, not bytes.)

  (let ((probe (assoc bm `(((1 gcbench:5)   .  3117802) ;tentative!
                           ((1 gcold:25_0_1_0_200) . 6946816)
                           ((1 gcold:25_0_1_1000_200) . 6946816)
                           ((1 gcold:25_0_10_1000_200) . 6946816)
                           ((1 nboyer:3)    .  3004302)
                           ((1 perm:200_8_10_1) . 3014656)
                           ((1 perm:25_8_10_8) . 3014656)
                           ((1 twobitshort) .  2175000) ;estimate!
                           ((1 twobitlong)  .  2175000) ;estimate!
                           ((5 earley:12)   .  2788466)
                           ((5 nboyer:3)    .  3004302)
                           ((5 sboyer:4)    .  3117802)
                           ((5 twobitshort) .  2175000))))) ; estimate!
    (if probe
        (* 4 (cdr probe))
        (error "profiled-peak-usage: can't find " bm))))

; eof
