; Various code to deal with HTML
; 2000-05-17 / lth

; All the files in filenames are assumed to reside in "html-tables/".

(define (merge-summary-html-tables output-file title filenames)

  (define (copy-text input output)
    (do ((c (read-char input) (read-char input)))
        ((eof-object? c))
      (write-char c output)))

  (call-with-output-file output-file
    (lambda (out)
      (format out "<html>~%")
      (format out "<head>~%")
      (format out "<title>~a</title>~%" title)
      (format out "</head>~%")
      (format out "<body>~%")
      (format out "<h1>~a</h1>~%" title)
      (do ((files filenames (cdr files)))
          ((null? files))
        (format out "<a href=\"#~a\">~a</a><br>~%" (car files) (car files)))
      (format out "<br>~%")
      (do ((files filenames (cdr files)))
          ((null? files))
        (format out "<a name=\"~a\">~%" (car files))
        (format out "<b>~a</b>~%" (string-upcase (car files)))
        (call-with-input-file (string-append "html-tables/" (car files) ".html")
          (lambda (in)
            (copy-text in out)
            (newline out)
            (format out "<hr>~%<br>~%"))))
      (format out "~a~%" (unix:current-timestamp))
      (format out "</body>~%")
      (format out "</html>~%"))))

; eof
