/* Compute timer resolution of getrusage() */

#include <sys/time.h>
#include <sys/resource.h>

int main(void)
{
  struct rusage b0, b1;
  int i, diff, sum = 0;

  getrusage( RUSAGE_SELF, &b1 );
  for ( i=0 ; i < 50 ; ) {
    getrusage( RUSAGE_SELF, &b0 );
    if (timercmp( &b0.ru_utime, &b1.ru_utime, > )) {
      diff = (int)(((long long)(b0.ru_utime.tv_sec)*1000000 
		    + (b0.ru_utime.tv_usec)) 
		   - ((long long)(b1.ru_utime.tv_sec)*1000000 
		      + (b1.ru_utime.tv_usec)));
      sum += diff;
      i++;
      b1 = b0;
    }
  }
  printf( "Average: %d microseconds\n", sum/i );
}
