; Copyright 1998 Lars T Hansen    -*- mode: scheme; indent-tabs-mode: nil -*-
;
; $Id: nbuild-param-C-el-unix.sch,v 1.1 1999/09/24 16:25:20 lth Exp $
;
; NBUILD parameters for Petit Larceny, endian-little, 32-bit, Unix OS.

(define (make-nbuild-parameter dir source? verbose? hostdir hostname)
  (let ((parameters 
         `((compiler       . ,(pathname-append dir "Compiler"))
           (util           . ,(pathname-append dir "Util"))
           (build          . ,(pathname-append dir "Rts" "Build"))
           (source         . ,(pathname-append dir "Lib"))
           (common-source  . ,(pathname-append dir "Lib" "Common"))
           (repl-source    . ,(pathname-append dir "Repl"))
           (interp-source  . ,(pathname-append dir "Interpreter"))
           (machine-source . ,(pathname-append dir "Lib" "Standard-C"))
           (common-asm     . ,(pathname-append dir "Asm" "Common"))
           (standard-C-asm . ,(pathname-append dir "Asm" "Standard-C"))
           (always-source? . ,source?)
           (verbose-load?  . ,verbose?)
           (compatibility  . ,(pathname-append dir "Compat" hostdir))
           (auxiliary      . ,(pathname-append dir "Auxlib"))
           (root           . ,dir)
           (host-system    . ,hostname)
           (target-machine . Standard-C)
           (target-os      . unix)
           (endianness     . little)
           (word-size      . 32)
           )))
    (lambda (key)
      (let ((probe (assq key parameters)))
        (if probe 
            (cdr probe)
            #f)))))

; eof
