(load ":src:Experimental:record.sch")
(load ":from sparc version:define-record.sch")
(load ":src:Auxlib:string.sch")
(load ":src:Auxlib:io.sch")
(load ":src:Auxlib:list.sch")
(load ":from sparc version:hashtable.sch")
(load ":src:Debugger:debug.sch")
(load ":src:Debugger:inspect-cont.sch")
(load ":src:Debugger:trace.sch")

(load "::research:textsearch.sch")

(define sophocles-queries
  '(gifts 
    (and gifts with)
    (and gifts (or with her))
    (show death)))

(define (test-sophocles)
  (textsearch "sophocles.txt" sophocles-queries))


; Optimized for interpreted code.

(define (read-line . rest)

  (define (loop p l)
    (let ((c (read-char p)))
      (cond ((eof-object? c)
             (if (null? l)
                 c
                 (list->string (reverse! l))))
            ((char=? c #\newline)
             (list->string (reverse! l)))
            (else
             (loop p (cons c l))))))

  (if (null? rest)
      (loop (current-input-port) '())
      (loop (car rest) '())))
