; Code for compiling benchmark programs, and code for the Twobit benchmark.
; $Id: compile-file.sch,v 1.2 1999/09/13 17:25:12 lth Exp $

; Extensions to compile-file.

(define (appropriate-fasl-file-name filename tag)
  (let* ((l (string-length filename))
         (suffix (substring filename (- l 4) l)))
    (if (not (member suffix '(".sch" ".scm")))
        (error "Don't know how to deal with " filename
               " -- must end in .sch or .scm.")
        (string-append (substring filename 0 (- l 4)) tag ".fasl"))))

(define compile-it
  (let ((compile-file compile-file))
    (lambda (filename alloc barrier tag)
      (compiler-switches 'fast-safe)
      (inline-allocation alloc)
      (write-barrier barrier)
      (compile-file filename (appropriate-fasl-file-name filename tag)))))

(define (compile-file-bdw filename)
  (compile-it filename #f #f "-bdw"))

(define (compile-file-gen filename)
  (compile-it filename #t #t "-gen"))

(define (compile-file-sc filename)
  (compile-it filename #t #f "-sc"))

(define (compile-file-common filename)
  (compile-it filename #f #t "-common"))

(define compile-file
  (let ((compile-file compile-file))
    (lambda args
      (display 
       "WARNING: compile-file is not suitable for compiling benchmarks.")
      (newline)
      (apply compile-file args))))

; eof
